/****************************************************************
   RTTY DECODER FOR DDH47 (SPACE CANCEL FUNCTION)
   5BIT-BAUDOT-CODE, 50baud
   LCD 16x2 (SD1602 HUOB-XA)
   ** THIS PROGRAM IS IN THE PUBLIC DOMAIN **
/****************************************************************/

#include <LiquidCrystal.h>
#include <FlexiTimer2.h>

LiquidCrystal lcd(4,5,6,7,8,9,10);

boolean  dsp;
byte     ti;
byte     x;
char     ch;
uint8_t  baudot;

void setup()
{
        lcd.begin(16, 2);
        lcd.cursor();
        lcd.setCursor(0, 0);
        FlexiTimer2::set(1, timer_interrupt);
        FlexiTimer2::start();
}

void timer_interrupt(void)
{
        static byte rSq;
        
        ti++;
        if(rSq == 0 && digitalRead(19) == 0)
        {
                rSq = 1;
                ti = 0;
        }
        if(rSq == 1 && ti == 10)
        {
                if(digitalRead(19) == 0)
                {
                        rSq = 2;
                        ti = 0;
                }
                else
                {
                        rSq = 0;
                }
        }
        if(rSq == 2 && ti == 20)
        {
                bitWrite(baudot, 0, digitalRead(19));
        }
        if(rSq == 2 && ti == 40)
        {
                bitWrite(baudot, 1, digitalRead(19));
        }
        if(rSq == 2 && ti == 60)
        {
                bitWrite(baudot, 2, digitalRead(19));
        }
        if(rSq == 2 && ti == 80)
        {
                bitWrite(baudot, 3, digitalRead(19));
        }
        if(rSq == 2 && ti == 100)
        {
                bitWrite(baudot, 4, digitalRead(19));
                dsp = 1;
        }
        if(rSq == 2 && ti == 120)
        {
                rSq = 0;
        }
}

//CONTROLS 16x2 LCD DISPLAY
void lcdOut()
{
        static byte y;
        static char c[17];
        int i;
        
        lcd.print(ch);
        c[x] = ch;
        x++;
        if(x == 16 && y == 0)
        {
                x = 0; y = 1;
        }
        else if(x == 16 && y == 1)
        {
                lcd.clear();
                lcd.noCursor();
                for(i = 0; i < 16; i++)
                {
                        lcd.print(c[i]);
                }
                lcd.cursor();
                x = 0; y = 1;
        }
        lcd.setCursor(x, y);
}

void lcdCrLf()
{
        byte rest = (16 - x);
        
        ch = ' ';
        lcd.noCursor();
        for(int i = 0; i < rest; i++) //FILL THE LINE WITH SPACES, INSTEAD OF CR&LF
        {
                lcdOut();
        }
        lcd.cursor();
}

void loop()
{
        static boolean fig;
        static boolean space;
        
        if(dsp == 1)
        {
                ch = '\0';
                     if(baudot == B11111){fig = 0;  } //LETTERS
                else if(baudot == B11011){fig = 1;  } //FIGURES            
                else if(baudot == B01000){ch = '\r';} //CR
                else if(baudot == B00010){          } //LF
                else if(baudot == B00100){ch = ' ' ;} //SPACE
                if(fig == 0)
                {
                             if(baudot == B00011){ch = 'A';}
                        else if(baudot == B11001){ch = 'B';}
                        else if(baudot == B01110){ch = 'C';}
                        else if(baudot == B01001){ch = 'D';}
                        else if(baudot == B00001){ch = 'E';}
                        else if(baudot == B01101){ch = 'F';}
                        else if(baudot == B11010){ch = 'G';}
                        else if(baudot == B10100){ch = 'H';}
                        else if(baudot == B00110){ch = 'I';}
                        else if(baudot == B01011){ch = 'J';}
                        else if(baudot == B01111){ch = 'K';}
                        else if(baudot == B10010){ch = 'L';}
                        else if(baudot == B11100){ch = 'M';}
                        else if(baudot == B01100){ch = 'N';}
                        else if(baudot == B11000){ch = 'O';}
                        else if(baudot == B10110){ch = 'P';}
                        else if(baudot == B10111){ch = 'Q';}
                        else if(baudot == B01010){ch = 'R';}
                        else if(baudot == B00101){ch = 'S';}
                        else if(baudot == B10000){ch = 'T';}
                        else if(baudot == B00111){ch = 'U';}
                        else if(baudot == B11110){ch = 'V';}
                        else if(baudot == B10011){ch = 'W';}
                        else if(baudot == B11101){ch = 'X';}
                        else if(baudot == B10101){ch = 'Y';}
                        else if(baudot == B10001){ch = 'Z';}
                }
                if(fig == 1)
                {
                             if(baudot == B00011){ch = '-';}
                        else if(baudot == B11001){ch = '?';}
                        else if(baudot == B01110){ch = ':';}
                        else if(baudot == B01001){         }
                        else if(baudot == B00001){ch = '3';}
                        else if(baudot == B01101){         }
                        else if(baudot == B11010){         }
                        else if(baudot == B10100){         }
                        else if(baudot == B00110){ch = '8';}
                        else if(baudot == B01011){         }
                        else if(baudot == B01111){ch = '(';}
                        else if(baudot == B10010){ch = ')';}
                        else if(baudot == B11100){ch = '.';}
                        else if(baudot == B01100){ch = ',';}
                        else if(baudot == B11000){ch = '9';}
                        else if(baudot == B10110){ch = '0';}
                        else if(baudot == B10111){ch = '1';}
                        else if(baudot == B01010){ch = '4';}
                        else if(baudot == B00101){         }
                        else if(baudot == B10000){ch = '5';}
                        else if(baudot == B00111){ch = '7';}
                        else if(baudot == B11110){         }
                        else if(baudot == B10011){ch = '2';}
                        else if(baudot == B11101){ch = '/';}
                        else if(baudot == B10101){ch = '6';}
                        else if(baudot == B10001){         }
                }
                if(ch != '\0')
                {
                        if(space && ch == '\r')
                        {
                                //SKIP
                        }
                        else if(space && ch == ' ')
                        {
                                //SKIP
                        }
                        else
                        {
                                if(ch == '\r')
                                {
                                        ch = ' ';
                                        lcdOut();
                                        space = true;
                                }
                                else if(ch == ' ')
                                {
                                        lcdOut();
                                        space = true;
                                }
                                else
                                {
                                        lcdOut();
                                        space = false;
                                }
                        }
                }
                dsp = 0;
        }
}

